// global constants from aviary browser.js
const NS_ERROR_MODULE_NETWORK = 2152398848;
const NS_NET_STATUS_READ_FROM = NS_ERROR_MODULE_NETWORK + 8;
const NS_NET_STATUS_WROTE_TO  = NS_ERROR_MODULE_NETWORK + 9;

//@line 38 "/cygdrive/c/builds/tinderbox/Fx-Trunk/WINNT_5.2_Depend/mozilla/browser/base/content/web-panels.js"

var panelProgressListener = {
    onProgressChange : function (aWebProgress, aRequest,
                                    aCurSelfProgress, aMaxSelfProgress,
                                    aCurTotalProgress, aMaxTotalProgress) {
    },
    
    onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
        if (!aRequest)
          return;

        //ignore local/resource:/chrome: files
        if (aStatus == NS_NET_STATUS_READ_FROM || aStatus == NS_NET_STATUS_WROTE_TO)
           return;

        const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
        const nsIChannel = Components.interfaces.nsIChannel;
        if (aStateFlags & nsIWebProgressListener.STATE_START && 
            aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
            window.parent.document.getElementById('sidebar-throbber').setAttribute("loading", "true");
        }
        else if (aStateFlags & nsIWebProgressListener.STATE_STOP &&
                aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
            window.parent.document.getElementById('sidebar-throbber').removeAttribute("loading");
        }
    }
    ,

    onLocationChange : function(aWebProgress, aRequest, aLocation) {
    },

    onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
    },

    onSecurityChange : function(aWebProgress, aRequest, aState) { 
    },

    QueryInterface : function(aIID)
    {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports))
        return this;
        throw Components.results.NS_NOINTERFACE;
    }
};

var gLoadFired = false;
function loadWebPanel(aURI) {
    var panelBrowser = document.getElementById('web-panels-browser');
    if (gLoadFired)
        panelBrowser.webNavigation.loadURI(aURI, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    panelBrowser.setAttribute("cachedurl", aURI);
}

function load()
{
  var panelBrowser = document.getElementById('web-panels-browser');
  panelBrowser.webProgress.addProgressListener(panelProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
  if (panelBrowser.getAttribute("cachedurl"))
    panelBrowser.webNavigation.loadURI(panelBrowser.getAttribute("cachedurl"), nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
  gNavigatorBundle = document.getElementById("bundle_browser");
    
  gLoadFired = true;

  // xSidebar - bookmark support for web-panels
  initServices();
  initBMService();
  BMSVC.readBookmarks();  
}

function unload()
{
  var panelBrowser = document.getElementById('web-panels-browser');
  panelBrowser.webProgress.removeProgressListener(panelProgressListener);
}

/// xSidebar mods

var xsbWebPanel = {

  // Replacement for nsContextMenu function addBookmark
  addBookmark : function () {
    var docshell = document.getElementById( "web-panels-browser" ).webNavigation;
    BookmarksUtils.addBookmark( docshell.currentURI.spec,
                                docshell.document.title,
                                docshell.document.characterSet,
                                false );
  },

  contextMenuInit : function () {
    var cm = document.getElementById("contentAreaContextMenu");
    if (cm)
      cm.addEventListener("popupshowing",xsbWebPanel.contextMenu,false);
  },

  contextMenu : function () {
    var cm = gContextMenu;
    if (cm) {
      cm.addBookmark = function addBookmark() {
        xsbWebPanel.addBookmark();
      }
    }
  }
}

function getBrowser()
{
  return top.document.getElementById("content");
}

// spin off from <https://bugzilla.mozilla.org/show_bug.cgi?id=321981>
// Neil says to cache a copy of the preference service which already has
// the nsIPrefBranch interface, you declare a global e.g.:

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

window.addEventListener("load", xsbWebPanel.contextMenuInit, true);
